#include "bintree1.h"
#include <UnitTest++/UnitTest++.h>

using namespace bintree;

TEST(Member_empty)
{
    Tree tree;
    CHECK(!member(tree, "a"));
}

TEST(Lookup_insert_throws)
{
    Tree tree;
    CHECK_THROW(lookup(tree, "a"), Not_found);
}

TEST(Insert_first_element_then_lookup)
{
    Tree tree;
    insert(tree, "b", 5);

    CHECK(!member(tree, "a"));
    CHECK(member(tree, "b"));
    CHECK_EQUAL(5, lookup(tree, "b"));
}

TEST(Insert_several)
{
    Tree tree;
    insert(tree, "d", 4);
    insert(tree, "b", 2);
    insert(tree, "a", 1);

    CHECK(member(tree, "a"));
    CHECK(member(tree, "b"));
    CHECK(!member(tree, "c"));
    CHECK(member(tree, "d"));
    CHECK(!member(tree, "e"));
    CHECK(!member(tree, "f"));
    CHECK(!member(tree, "g"));

    insert(tree, "c", 3);
    insert(tree, "f", 6);
    insert(tree, "e", 5);
    insert(tree, "g", 7);

    CHECK(member(tree, "a"));
    CHECK(member(tree, "b"));
    CHECK(member(tree, "c"));
    CHECK(member(tree, "d"));
    CHECK(member(tree, "e"));
    CHECK(member(tree, "f"));
    CHECK(member(tree, "g"));
    CHECK(!member(tree, ""));
    CHECK(!member(tree, "ax"));
    CHECK(!member(tree, "bx"));
    CHECK(!member(tree, "cx"));
    CHECK(!member(tree, "dx"));
    CHECK(!member(tree, "ex"));
    CHECK(!member(tree, "fx"));
    CHECK(!member(tree, "gx"));

    CHECK_EQUAL(1, lookup(tree, "a"));
    CHECK_EQUAL(2, lookup(tree, "b"));
    CHECK_EQUAL(3, lookup(tree, "c"));
    CHECK_EQUAL(4, lookup(tree, "d"));
    CHECK_EQUAL(5, lookup(tree, "e"));
    CHECK_EQUAL(6, lookup(tree, "f"));
    CHECK_EQUAL(7, lookup(tree, "g"));

    CHECK_THROW(lookup(tree, "h"), Not_found);
}

